Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
To help users with their search, Algolia provides Query Suggestions. This feature creates an with the best queries generated by users. You can then use this index to propose suggestions to your users as they’re typing into a search input. Once you’ve configured the generation of the Query Suggestions index, you need to query this index as well. You can use the <Autocomplete> widget for that. This guide shows how to use <Autocomplete> to display a list of suggestions. Once users select a suggestion, it will apply the query.

Open CodeSandbox

Run and edit the Query Suggestions UI example in CodeSandbox.

Explore source code

Browse the source for the Query Suggestions UI example on GitHub.

Refine your results with suggestions

To set up multi-index search experience so users can select a suggestion and use it to search the main index:
1

Create the multi-index search experience

The <Autocomplete> widget can target the index that contains the suggestions, and the rest of the widgets target the main index that holds the data. For more information, see Multi-index search.
React
// ...

import { EXPERIMENTAL_Autocomplete } from 'react-instantsearch';

export function App() {
  return (
    <InstantSearch
      searchClient={searchClient}
      indexName="instant_search"
    >
      <EXPERIMENTAL_Autocomplete
        showSuggestions={{
          indexName: 'instant_search_demo_query_suggestions',
        }}
      />
      <Hits hitComponent={HitComponent} />
    </InstantSearch>
  )
}
Last modified on May 19, 2026

Skip to main content
To help users with their search, Algolia provides Query Suggestions. This feature creates an of your user’s best queries. You can then use this index to propose suggestions to your users as they’re typing into the ais-search-box. Once you’ve configured the generation of the Query Suggestions index, you need to query this index as well. Use multi-index search to do that. This guide shows how to use a search box to display a list of suggestions and their associated categories. Once users select a suggestion, Algolia will apply the query and the category. If you’re building an autocomplete with Query Suggestions, you should use the Autocomplete library which lets you build a full-featured, accessible autocomplete experience. This is the recommended way of building an autocomplete search with Algolia. For more information, see:

Working example

Open CodeSandbox

Run and edit the Query Suggestions UI example in CodeSandbox.

Explore source code

Browse the source for the Query Suggestions UI example on GitHub.
This code has been specifically created for Vue 2. Some modifications may be required for it to work correctly in Vue 3.

Refine your results with suggestions

To set up multi-index search experience so users can select a suggestion and use it to search the main index:
1

Set up custom autocomplete component

Set up a custom autocomplete component with the Vue Autosuggest library.
2

Wrap the conponent in the connector

Wrap the autocomplete component with the ais-autocomplete connector. For more infomation, see Autocomplete.
Vue
<template>
  <ais-instant-search
    :search-client="searchClient"
    index-name="instant_search_demo_query_suggestions"
  >
    <ais-configure :hitsPerPage="5" />
    <ais-autocomplete>
      <template v-slot="{ currentRefinement, indices, refine }">
        <vue-autosuggest
          :suggestions="indicesToSuggestions(indices)"
          @selected="onSelect"
          :input-props="{
            style: 'width: 100%',
            onInputChange: refine,
            placeholder: 'Search here...',
          }"
        >
          <template v-slot="{ suggestion }">
            <ais-highlight attribute="query" :hit="suggestion.item" />
          </template>
        </vue-autosuggest>
      </template>
    </ais-autocomplete>
  </ais-instant-search>
</template>

<script>
import { VueAutosuggest } from 'vue-autosuggest';

export default {
  components: { VueAutosuggest },
  methods: {
    onSelect(selected) {
      if (selected) {
        console.log('selected');
      }
    },
    indicesToSuggestions(indices) {
      return indices.map(({ hits }) => ({
        data: hits.map(hit => {
          return {
            ...hit,
            // this is for Vue AutoSuggest
            name: hit.query,
          };
        }),
      }));
    },
  },
};
</script>
3

Create the multi-index search experience

The ais-autocomplete widget reads from two indices: instant_search_demo_query_suggestions and instant_search. The first index widget is implied by the creation of the ais-instant-search widget.
Vue
<template>
  <div>
    <ais-instant-search
      :search-client="searchClient"
      index-name="instant_search_demo_query_suggestions"
    >
      <ais-configure :hitsPerPage="5" />
      <ais-index index-name="instant_search" />
      <ais-autocomplete>
        <template v-slot="{ currentRefinement, indices, refine }">
          <vue-autosuggest
            :suggestions="indicesToSuggestions(indices)"
            @selected="onSelect"
            :input-props="{
              style: 'width: 100%',
              onInputChange: refine,
              placeholder: 'Search here...',
            }"
          >
          <template v-slot="{ suggestion }">
            <ais-highlight
              :hit="suggestion.item"
              attribute="query"
              v-if="suggestion.item.query"
            />
            <ais-highlight
              :hit="suggestion.item"
              attribute="name"
              v-else
            />
            <strong v-if="suggestion.item.price">
              $ {{ suggestion.item.price }}
            </strong>
            <img
              :src="suggestion.item.image"
              style="height: 50px;"
              v-if="suggestion.item.image"
            />
          </template>
          </vue-autosuggest>
        </template>
      </ais-autocomplete>
    </ais-instant-search>
  </div>
</template>

<script>
import { VueAutosuggest } from 'vue-autosuggest';

export default {
  components: { VueAutosuggest },
  methods: {
    onSelect(selected) {
      if (selected) {
        const { query } = selected.item;
        this.query = query;
      }
    },
    indicesToSuggestions(indices) {
      return indices.map(({ hits }) => ({
        data: hits.map(hit => {
          return {
            ...hit,
            // this is for Vue Autosuggest
            name: hit.query,
          };
        }),
      }));
    },
  },
};
</script>
A typical use of autocomplete is to display both relevant categories and suggestions. Then when a user selects a suggestion, both the suggestion and the associated category are used to refine the search. For this example, the relevant categories are stored on the suggestions . You must update your render function to display the categories with the suggestions. For simplicity and brevity of the code, assume that all suggestions have categories, but this isn’t the case in the actual dataset. Take a look at the complete example to see the actual implementation.
Vue
<template>
  <!-- ... -->
    <template v-slot="{ suggestion }">
      <span>
        <ais-highlight attribute="query" :hit="suggestion.item" />
        <span>
          <em>
            in
            <span v-if="suggestion.item.category">
              {{ suggestion.item.category.value }}
            </span>
            <span v-else> All categories </span>
          </em>
        </span>
      </span>
    </template>
  <!-- ... -->
</template>

<script>
export default {
  methods:
    indicesToSuggestions(indices) {
      return indices.map(({ hits }) => ({
        data: hits.map(hit => {
          // categories is an array, but you only want the first element
          // hit.instant_search is undefined if there are no matched categories
          const [category] =
            (hit.instant_search &&
              hit.instant_search.facets.exact_matches.categories) ||
            [];

          return {
            ...hit,
            category,
            name: hit.query,
          };
        }),
      }));
    },
  },
};
</script>
Now that you can display categories, you can use them to refine the main search. Use the ais-configure widget with disjunctiveFacets and disjunctiveFacetsRefinement. These two parameters are the same as internally used in a refinement list.
Vue
<template>
  <!-- ... -->
  <ais-instant-search
    :search-client="searchClient"
    index-name="instant_search"
  >
    <!-- optionally to display the selected category -->
    <ais-current-refinements />
    <ais-configure
      :query="query"
      :disjunctiveFacets="['categories']"
      :disjunctiveFacetsRefinements="disjunctiveFacetsRefinements"
    />
    <!-- ... -->
  </ais-instant-search>
</template>

<script>
export default {
  data() {
    return {
      query: '',
      disjunctiveFacetsRefinements: undefined,
    };
  },
  methods: {
    onSelect(selected) {
      if (selected) {
        const { query, category } = selected.item;
        this.query = query;
        this.disjunctiveFacetsRefinements = category && {
          categories: [category.value],
        };
      }
    },
  },
};
</script>
That’s it. When a suggestion is selected, both the query and the category are applied to the main search.
Last modified on May 19, 2026

🎉 Try the public beta of the new docs site at algolia.com/doc-beta! 🎉
Guides / Building Search UI / UI & UX patterns / Query Suggestions

Build a Query Suggestions UI with Angular InstantSearch

To help users with their search, Algolia provides Query Suggestions.

This feature creates an index with the best queries done by your users.

You can use this index to provide your users with suggestions as they’re typing into the ais-search-box.

The advantage of this feature is that, once you’ve configured the generation of the index, it’s a matter of querying another index to provide the user with suggestions. You can do this by implementing a multi-index search.

This guide shows how to use a search box to display a list of suggestions and their associated categories. Once the user selects a suggestion, the engine will apply the query and the category. This guide doesn’t cover the details of how to integrate autocomplete with Angular InstantSearch (however, the autocomplete guide has a dedicated section on that topic).

You can find the source code for this tutorial on GitHub.

Refine your results with the suggestions

Step one: set up your boilerplate for displaying results

Start with a regular InstantSearch boilerplate as generated by create-instantsearch-app.

1
2
3
4
5
6
7
8
9
10
11
<!-- app.component.html -->
<ais-instantsearch [config]="configResults">
  <ais-configure [searchParameters]="searchParameters"></ais-configure>
  <ais-hits>
    <ng-template let-hits="hits" let-results="results">
      <div *ngFor="let hit of hits">
        <ais-highlight attribute="name" [hit]="hit"></ais-highlight>
      </div>
    </ng-template>
  </ais-hits>
</ais-instantsearch
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
import { Component } from '@angular/core';
import algoliasearch from 'algoliasearch';

const searchClient = algoliasearch(
  'latency',
  '6be0576ff61c053d5f9a3225e2a90f76'
);

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  public configResults = {
    indexName: 'instant_search',
    searchClient,
  };

  public searchParameters = { query: '' };
}

Step two: fetching suggestions

Use the Angular Material component to connect with the autocomplete connector. You can find more information in the autocomplete guide

Create an AutocompleteComponent component to extend the BaseWidget class with the connectAutocomplete connector as follows:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
// autocomplete.component.js
import {
  Component,
  Inject,
  forwardRef,
} from "@angular/core";
import { BaseWidget, NgAisInstantSearch } from "angular-instantsearch";
import { connectAutocomplete } from "instantsearch.js/es/connectors";

@Component({
  selector: "app-autocomplete",
  template: ``
})
export class AutocompleteComponent extends BaseWidget {
  state: {
    query: string;
    refine: Function;
    indices: object[];
  };

  constructor(
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchParent
  ) {
    super("AutocompleteComponent");
  }

  public ngOnInit() {
    this.createWidget(connectAutocomplete, {});
    super.ngOnInit();
  }
}

Now add another InstantSearch instance that will query the suggestions index instant_search_demo_query_suggestions.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
<!-- app.component.html -->
<ais-instantsearch [config]="configSuggestions">
  <app-autocomplete></app-autocomplete>
</ais-instantsearch

<ais-instantsearch [config]="configResults">
  <ais-configure [searchParameters]="searchParameters"></ais-configure>
  <ais-hits>
    <ng-template let-hits="hits" let-results="results">
      <div *ngFor="let hit of hits">
        <ais-highlight attribute="name" [hit]="hit"></ais-highlight>
      </div>
    </ng-template>
  </ais-hits>
</ais-instantsearch
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
// app.component.ts
import { Component } from '@angular/core';
import algoliasearch from 'algoliasearch';

const searchClient = algoliasearch(
  'latency',
  '6be0576ff61c053d5f9a3225e2a90f76'
);

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  public configSuggestions = {
    indexName: 'instant_search_demo_query_suggestions',
    searchClient,
  };
  public configResults = {
    indexName: 'instant_search',
    searchClient,
  };

  public searchParameters = { query: '' };
}
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
// app.module.ts
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { NgAisModule } from 'angular-instantsearch';

import { AppComponent } from './app.component';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

import { AutocompleteComponent } from './autocomplete.component'

@NgModule({
  declarations: [
    AppComponent,
    AutocompleteComponent
  ],
  imports: [
    NgAisModule.forRoot(),
    BrowserModule,
    BrowserAnimationsModule,
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }

Your AutocompleteComponent can now fetch the suggestions from instant_search_demo_query_suggestions.

The next step is to display these suggestions attractively using Angular Material Autocomplete.

Step three: import and populate Angular Material Autocomplete with suggestions

To import everything you need in your app to use Angular Material Autocomplete in your code:

  1. Make sure you have @angular/material installed, or run this in the root directory of your project.

    $
    
     ng add @angular/material
    
  2. Import MatInputModule, MatAutocompleteModule inside your project, as well as your newly created AutocompleteComponent.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    
     import { BrowserModule } from '@angular/platform-browser';
     import { NgModule } from '@angular/core';
     import { NgAisModule } from 'angular-instantsearch';
     import { AppComponent } from './app.component';
     import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
    
     import { AutocompleteComponent } from './autocomplete.component'
     import { MatInputModule, MatAutocompleteModule } from '@angular/material';
    
     @NgModule({
       declarations: [
         AppComponent,
         AutocompleteComponent
       ],
       imports: [
         NgAisModule.forRoot(),
         BrowserModule,
         BrowserAnimationsModule,
         MatInputModule,
         MatAutocompleteModule,
       ],
       providers: [],
       bootstrap: [AppComponent]
     })
     export class AppModule { }
    
  3. Use MatInputModule, MatAutocompleteModule inside AutocompleteComponent.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    
     // autocomplete.component.js
     import {
       Component,
       Inject,
       forwardRef,
       EventEmitter,
       Output
     } from "@angular/core";
     import { BaseWidget, NgAisInstantSearch } from "angular-instantsearch";
     import { connectAutocomplete } from "instantsearch.js/es/connectors";
    
     @Component({
       selector: "app-autocomplete",
       template: `
         <div>
           <input
             matInput
             [matAutocomplete]="auto"
             (keyup)="handleChange($event)"
             style="width: 100%; padding: 10px"
           />
           <mat-autocomplete
             #auto="matAutocomplete"
             style="margin-top: 30px; max-height: 600px"
           >
             <div *ngFor="let index of state.indices || []">
               <mat-option
                 *ngFor="let hit of index.hits"
                 [value]="hit.query"
                 (click)="this.onQuerySuggestionClick.emit(hit.query)"
               >
                 {{ hit.query }}
               </mat-option>
             </div>
           </mat-autocomplete>
         </div>
       `
     })
     export class AutocompleteComponent extends BaseWidget {
       state: {
         query: string;
         refine: Function;
         indices: object[];
       };
    
       @Output() onQuerySuggestionClick: EventEmitter<any> = new EventEmitter();
    
       constructor(
         @Inject(forwardRef(() => NgAisInstantSearch))
         public instantSearchParent
       ) {
         super("AutocompleteComponent");
       }
    
       public handleChange($event: KeyboardEvent) {
         this.state.refine(($event.target as HTMLInputElement).value);
       }
    
       public ngOnInit() {
         this.createWidget(connectAutocomplete, {});
         super.ngOnInit();
       }
     }
    
  4. Refresh results based on selected query

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    
     <!-- app.component.html -->
     <ais-instantsearch [config]="configSuggestions">
       <app-autocomplete (onQuerySuggestionClick)="setQuery($event)"></app-autocomplete>
     </ais-instantsearch
    
     <ais-instantsearch [config]="configResults">
       <ais-configure [searchParameters]="searchParameters"></ais-configure>
       <ais-hits>
         <ng-template let-hits="hits" let-results="results">
           <div *ngFor="let hit of hits">
             <ais-highlight attribute="name" [hit]="hit"></ais-highlight>
           </div>
         </ng-template>
       </ais-hits>
     </ais-instantsearch
    
    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    
     import { Component } from '@angular/core';
     import algoliasearch from 'algoliasearch';
    
     const searchClient = algoliasearch(
       'latency',
       '6be0576ff61c053d5f9a3225e2a90f76'
     );
    
     @Component({
       selector: 'app-root',
       templateUrl: './app.component.html',
       styleUrls: ['./app.component.css']
     })
     export class AppComponent {
       public configSuggestions = {
         indexName: 'instant_search_demo_query_suggestions',
         searchClient,
       };
       public configResults = {
         indexName: 'instant_search',
         searchClient,
       };
    
       public searchParameters = { query: '' };
    
       public setQuery(query : string) {
         this.searchParameters.query = query
       }
     }
    

A typical use of autocomplete is to display both relevant categories and suggestions. Then when a user selects a suggestion, both the suggestion and the associated category are used to refine the search. For this example, the relevant categories are stored on the suggestions records. You must update your render function to display the categories with the suggestions. For simplicity and brevity of the code, assume that all suggestions have categories, but this isn’t the case in the actual dataset. Take a look at the complete example to see the actual implementation.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
// autocomplete.component.ts
import {
  Component,
  Inject,
  forwardRef,
  EventEmitter,
  Output
} from "@angular/core";
import { BaseWidget, NgAisInstantSearch } from "angular-instantsearch";
import { connectAutocomplete } from "instantsearch.js/es/connectors";

@Component({
  selector: "app-autocomplete",
  template: `
    <div>
      <input
        matInput
        [matAutocomplete]="auto"
        (keyup)="handleChange($event)"
        style="width: 100%; padding: 10px"
      />
      <mat-autocomplete
        #auto="matAutocomplete"
        style="margin-top: 30px; max-height: 600px"
      >
        <div *ngFor="let index of state.indices || []">
          <mat-option
            *ngFor="let hit of index.hits"
            [value]="hit.query"
            (click)="this.onQuerySuggestionClick.emit({query: hit.query, category: hasCategory(hit) ? getCategory(hit) : null })"
          >
            {{ hit.query }}
            <span>
              in
              <em *ngIf="hasCategory(hit)"> {{ getCategory(hit) }} </em>
              <em *ngIf="!hasCategory(hit)"> All categories </em>
            </span>
          </mat-option>
        </div>
      </mat-autocomplete>
    </div>
  `
})
export class AutocompleteComponent extends BaseWidget {
  state: {
    query: string;
    refine: Function;
    indices: object[];
  };

  @Output() onQuerySuggestionClick: EventEmitter<any> = new EventEmitter();

  constructor(
    @Inject(forwardRef(() => NgAisInstantSearch))
    public instantSearchParent
  ) {
    super("AutocompleteComponent");
  }

  hasCategory(hit) {
    return (
      hit.instant_search &&
      hit.instant_search.facets &&
      hit.instant_search.facets.exact_matches &&
      hit.instant_search.facets.exact_matches.categories &&
      hit.instant_search.facets.exact_matches.categories.length
    );
  }

  getCategory(hit) {
    const [category] = hit.instant_search.facets.exact_matches.categories;
    return category.value;
  }

  public handleChange($event: KeyboardEvent) {
    this.state.refine(($event.target as HTMLInputElement).value);
  }

  public ngOnInit() {
    this.createWidget(connectAutocomplete, {});
    super.ngOnInit();
  }
}

Now that you can display the categories, use them to refine the main search (using the same strategy as the query). Use the ais-configure widget with disjunctiveFacets and disjunctiveFacetsRefinement. These two parameters are the same ones as internally used in a refinement list.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
// app.component.ts
import { Component } from '@angular/core';
import algoliasearch from 'algoliasearch';

const searchClient = algoliasearch(
  "latency",
  "6be0576ff61c053d5f9a3225e2a90f76"
);

@Component({
  selector: "app-root",
  templateUrl: "./app.component.html",
  styleUrls: ["./app.component.css"]
})
export class AppComponent {
  public configSuggestions = {
    indexName: "instant_search_demo_query_suggestions",
    searchClient
  };
  public configResults = {
    indexName: "instant_search",
    searchClient
  };

  public searchParameters : {
    query: string;
    disjunctiveFacets?: string[];
    disjunctiveFacetsRefinements?: object;
  } = { query: ""};

  setQuery({ query, category }: { query: string; category: string }) {
    this.searchParameters.query = query;
    if (category) {
      this.searchParameters.disjunctiveFacets = ["categories"];
      this.searchParameters.disjunctiveFacetsRefinements = {
        categories: [category]
      };
    }
  }
}

Now when a suggestion is selected both the query and the category are applied to the main search.

Did you find this page helpful?